function tso = set(ts,varargin)
% @TESTSET/SET  Sets the properties
%
%  This is the main accessor setter method.

% Iterate on inputs
property_argin = varargin;
while length(property_argin) >= 2,
    % Get a piece of input
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    
    % Check type of prop:
    if not(isa(prop,'char'))
        error('A char is required for properties in get/set methods!');
    end
    
    % Changing some names:
    if strcmp(prop,'env') prop='data'; end
    
    % Check the required property:
    switch prop
        % The set of tests:
        case 'tests'
            ts.tests = val;
        % A property that can be set from the parent class:
        otherwise
            tu = set(ts.testunit,prop,val);
            ts.testunit = tu;
    end
end

% Returning:
tso = ts;
