function tuo = test(tu)
  % @TESTUNIT/TEST  Run the test
  %
  %  This function run the test and generates the output status, the
  % statistics and the output data.
  
  % Resetting:
  tu = reset(tu);
  
  % Getting actual time:
  tu.stats.startingTime = now;
  %   tStart=tic;
  tStart=clock;
  
  % Preparing data:
  func = get(tu,'func');
  tdata = get(tu,'data');
  %   disp(['Extract tdata ' tdata '-- for ' tu.name]);
  try error('MUnit:test',''); end
  
  % Catching errors:
  try
    % Executing the function:
    %     disp(['Executing ' char(func)]);
    switch class(tu)
      case 'testunit'
        feval(func,tdata);
        tu.status = 0;
      case 'testset'
        [tu,success,results] = feval(func,tu,tdata);
        tu.status = success;
        tu.results = results;
    end
    
  catch
    % Saving results:
    tu.status = 1;
  end
  
  % If an error occour memorize it
  % msg = lasterr;
  % pos = strfind(msg,sprintf('\n'));
  % if pos msg=msg(pos+1:size(msg,2)); end
  tu.err = lasterror;
  
  % Obtaining the final time:
  tu.stats.endingTime = now;
%  tu.stats.elapsed = toc(tStart);
  tu.stats.elapsed = etime(clock(), tStart);
  
  % Triggering the termination event:
  tuo = triggerEvent(tu,2);
