function tuo = triggerEvent(tu,event)
% @TESTUNIT/TRIGGEREVENT  Triggers an event that must be managed from the callbacks
%
%  This function allows to manage a triggered event. The event must be an
% integer representing a callback.

% Get callbacks:
cbs = get(tu,'callbacks');

% Check the size
if event<1 || event>size(cbs,2)
    warning('The indicated event isn''t a known event');
end

% Iterating on callbacks
for ind=1:size(cbs{event},2)
    % Check the callback:
    if isa(cbs{event},'function_handle')
        % Calling the callback with the testunit as parameter:
        tu = feval(cbs{event},tu,event);
    elseif isa(cbs{event},'cell') && isa(cbs{event}{ind},'function_handle')
        tu = feval(cbs{event}{ind},tu,event);
    else
        warning('Bad callback');
    end
end

% Returning:
tuo = tu;
